#include <iostream>
#include <algorithm>
#include <cstdio>
#include <stack>

#define MaxP 200000
#define MaxT 1000000

using namespace std;

struct TToc{
	int x, lr, tip, d, nom;
};

struct TPr{
	int x, d, nom, tip;
};
struct TPraw{
	int x1,y1,x2,y2,x3,y3,x4,y4;
};

int b1[MaxP], b2[MaxP], n1, n2, d1, d2, bKw, C, br[MaxP], bPr;
TToc t[MaxT];
bool flag[MaxT];
TPr pr[MaxP];
int brObl;

bool fff(TToc t1, TToc t2){
	if (t1.x<t2.x) return true;
	else
	if (t1.x==t2.x) {
		return (t2.tip>t1.tip);
	}
	return false;
}

bool fffPr(TPr t1, TPr t2){
	if (t1.x<t2.x) return true;
	else
	if (t1.x==t2.x) {
		return (t2.tip>t1.tip);
	}
	return false;
}

bool fffPr1(TPr t1, TPr t2){
	return (t1.nom<t2.nom);
}

int dwTr(int a[], int L, int R, int K){
int M;
	if (R==0) return R+1;
	if (K < a[R]) return R+1;
	if (K > a[L]) return 1;
    if (a[R]==K) return R;
    if (a[L]==K) return L;
    while (L < R) {
     	M = (L + R) / 2;
     	if (a[M]==K) return M;
      	if (K < a[M]) {
        	L = M + 1;
      	} else {
        	R = M;
      	}
    }
    if (a[M]>K) M++;
    return M;
}

void ObrB1(int i){
	if (t[i].lr==1) {
		d1=d1+1;
		b1[d1]=t[i].d;
	}
	else{
		b1[d1]=0; d1--;
	}
}

void ObrB2(int i){
			if (t[i].lr==1)	{		//    
				d2++;
				b2[d2]=t[i].d;
			}
			else{
				b2[d2]=0; d2--;
			}
}

int EdinWdrug (){
int x,i,j;

	i=1; j=1; x=0;
	while (1) {
		if (b1[i]==b2[j]) i++, j++, x++;
		else
		if (b1[i]<b2[j]) {
			if (i<=n1) i++;
		}
		else
		if (j<=n2) j++;

		if (i>n1 or j>n2) break;
	}
	return (n1+n2-x);
}

bool PresPr(int p1, int p2){
int x1,x2;

	if (pr[p1].x==pr[p2].x) return true;
	if (pr[p1].x>pr[p2].x) swap(p1,p2);

	x1=pr[p1].x; x2=pr[p2].x;
	if (x1<=x2 and x2<=x1+pr[p1].d){
		if (pr[p1].d<=pr[p2].d) return true;
		if (x1+pr[p1].d<=x2+pr[p2].d) return true;
	}
	return false;
}

bool Wytre (int p1, int p2){
	if (pr[p1].d>pr[p2].d) return false;
	if (pr[p1].x<pr[p2].x) swap(p1,p2);
	return (pr[p1].x+pr[p1].d<pr[p2].x+pr[p2].d);
}

int ObrGr(){
int i,p1,p2, broj=0, tekRod;
bool fl=false;

	for (i=1; i<=bPr; i++){
		br[i]=i;
		if (pr[i].tip==1){
			if (d2>0){
				p2=b2[d2];
				while (Wytre(i,p2)){
					b2[d2]=0; d2--;
					if (d2==0) break;
					p2=b2[d2];
				}
				if (d2>0){
					p2=b2[d2];
					int dd=d2;
					fl=false;
					while (PresPr(i,p2)){
						if (br[p2]>0) {
							fl=true;
							tekRod=br[p2];
						}
						br[p2]=i;
						dd--;
						if (dd==0) break;
						p2=b2[dd];
					}
					if (fl){
						br[i]=tekRod;
					}
				}
			}
			d1++; b1[d1]=i;
		}
		else{
			if (d1>0){
				p1=b1[d1];
				while (Wytre(i,p1)){
					b1[d1]=0; d1--;
					if (d1==0) break;
					p1=b1[d1];
				}
				if (d1>0){
					p1=b1[d1];
					fl=false;
					while (pr[i].x>=(pr[p1].x+pr[p1].d)){
						if ((pr[i].x==pr[p1].x) or (pr[i].x==pr[p1].x+pr[p1].d))
						{
							if (br[p1]>0) {
								fl=true;
								tekRod=br[p1];
							}
							br[p1]=i;
						}
						b1[d1]=0; d1--;
						if (d1==0) break;
						p1=b1[d1];
					}
					if (fl){
						br[i]=tekRod;
					}
				}
				if (d1>0){
					p1=b1[d1];
					int dd=d1;
					while (PresPr(i,p1)){
						if (br[p1]>0) {
							fl=true;
							tekRod=br[p1];
						}
						br[p1]=i;
						dd--;
						if (dd==0) break;
						p1=b1[dd];
					}
					if (fl){
						br[i]=tekRod;
					}
				}
			}
			d2++; b2[d2]=i;
		}
	}

	for (i=1; i<=bPr; i++) flag[i]=true;
	broj=0;
	for (i=1; i<=bPr; i++){
		if (flag[i]){
			broj++;
			p1=br[i]; flag[i]=false;
			while (p1!=i){
				if (flag[p1]==false) {
					broj--;
					break;
				}
				flag[p1]=false;
				p1=br[p1];
			}
		}
	}

	return broj;

}

int main ()
{
long long int i, j, x, xx1, d,k, bt, t2=0, t3=0, t4=0, R, F, V, M, K;
bool fl;

//	freopen("rect.38.in","rt",stdin);
//	freopen("rect.38.sol","wt",stdout);
	bt=0; bKw=0; bPr=0;
	cin>>n1;
	cin>>x; xx1=x;
	for (i=1; i<=n1; i++){
		cin>>d;
		pr[++bPr].x=x-d/2; pr[bPr].d=d; pr[bPr].tip=1; pr[bPr].nom=i;
		b1[i]=d;
		bt++;
		t[bt].x=x-d/2; t[bt].nom=++bKw;
		t[bt].tip=1; t[bt].lr=1; t[bt].d=d;
		bt++;
		t[bt].x=x+d/2;  t[bt].nom=bKw;
		t[bt].tip=1; t[bt].lr=0; t[bt].d=d;
	}
	cin>>n2;
	cin>>x;
	for (i=1; i<=n2; i++){
		cin>>d;
		pr[++bPr].x=x-d/2; pr[bPr].d=d; pr[bPr].tip=2;  pr[bPr].nom=i;
		b2[i]=d;
		bt++;
		t[bt].x=x-d/2; t[bt].nom=++bKw;
		t[bt].tip=2; t[bt].lr=1; t[bt].d=d;
		bt++;
		t[bt].x=x+d/2; t[bt].nom=bKw;
		t[bt].tip=2; t[bt].lr=0; t[bt].d=d;
	}

	if (x==xx1){
		cout<<EdinWdrug()<<endl;
		return 0;
	}

	sort(t+1, t+bt+1,fff);

	for (i=1; i<=n1; i++) b1[i]=0;
	for (i=1; i<=n2; i++) b2[i]=0;
	for (i=1; i<=bt; i++) flag[i]=true;

	d1=0; d2=0;
	i=0;
	while (true){
		i++;
		fl=true;
//		cout<<d1<<" "<<d2<<endl;
		if (t[i].tip==1){ //  
			if (t[i+1].tip==2 and t[i].x==t[i+1].x){ //    
				t3+=2; //br[t[i].nom]++; br[t[i+1].nom]++;
				if (t[i].d>t[i+1].d) {		//  > 
					M=dwTr(b2,1,d2,t[i].d);	//      
					k=d2-M+1;
					if (t[i+1].lr==0)
						k--;
					if (k>0)
						if (b2[M]==t[i].d){//     
							t3=t3+2;
							k--; fl=false;
						}
					if (fl)	{			//     
						t2+=2;			//   
					}
					if (k>0){
						t4=t4+2*k;
					}
					ObrB1(i);
					i++;
					ObrB2(i);
				}
				else
				if (t[i].d < t[i+1].d) {			//  < 
					M=dwTr(b1,1,d1,t[i+1].d);	//      
					k=d1-M+1;
					if (t[i].lr==0)
						k--;
					if (k>0)
						if (b1[M]==t[i+1].d){		//     
							t3=t3+2;
							k--; fl=false;
						}
					if (fl)	{			//     
						t2+=2;			//   
					}
					if (k>0)
						t4=t4+2*k;
					ObrB1(i);
					i++;
					ObrB2(i);
				}
				else {
					if (t[i].lr==t[i+1].lr){
						t3=t3-2; t2+=2;
					}
					ObrB1(i);
					i++;
					ObrB2(i);
				}
			}
			else { 		//   
				M=dwTr(b2,1,d2,t[i].d);		//      
				k=d2-M+1;
				if (k>0){
					//br[t[i].nom]++;
					if (b2[M]==t[i].d){	//     
						t3=t3+2;
						k--; fl=false;
					}
				}
				if (fl)	{				//     
					t2+=2;				//   
				}
				if (k>0)
					t4=t4+2*k;
				ObrB1(i);
			}
		}
		else {
//  
			M=dwTr(b1,1,d1,t[i].d);	//      
			k=d1-M+1;
			if (k>0){
				//br[t[i].nom]++;
				if (b1[M]==t[i].d){		//     
					t3=t3+2;
					k--; fl=false;
				}
			}
			if (fl)	{			//     
				t2+=2;			//   
			}
			if (k>0)
				t4=t4+2*k;
			ObrB2(i);
		}

		if (i>=bt) break;
	}
//	cout<<t2<<" "<<t3<<" "<<t4<<endl;
	for (i=1; i<=n1; i++) b1[i]=0;
	for (i=1; i<=n2; i++) b2[i]=0;
	for (i=1; i<=bt; i++) flag[i]=false;
	d1=d2=0;
	sort(pr+1,pr+bPr+1,fffPr);
	K=ObrGr();			//     
//	cout<<K<<endl;
//	cout<<"V= "<<(t2+t3+t4)<<"  R= "<<(t2*2+t3*3+t4*4)/2<<endl;
//     
	cout<<(t2*2+t3*3+t4*4)/2 + K - (t2+t3+t4)<<endl;


  return 0;
}
