#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <set>
using namespace std;
typedef long long llong;

int Xa, Xb;
int n,m;
int A[200111];
int B[200111];

void invert()
{
    int i;
    for (i=1;i<=max(n,m);i++)
    {
        swap(A[i], B[i]);
    }
    swap(n, m);
}

llong getAreas(bool equalizer)
{
    int i;
    int D = abs(Xa - Xb);
    llong ans = 0;

    int firstNice = m + 1;
    int lastNice = 0;
    int blocker = 1;
    int firstChop = m + 1;
    int lastChop = 0;

    for (i=1;i<=n;i++)
    {
        ///Nice ones
        while(firstNice > 0 && B[firstNice-1] >= A[i] && B[firstNice-1] + A[i] > D)
            firstNice--;
        while(firstNice <= m && B[firstNice] < A[i])
            firstNice++;

        if (!equalizer && firstNice <= m && B[firstNice] == A[i])
            firstNice++;

        while(lastNice < m && B[lastNice+1] < D + A[i])
            lastNice++;

        ///Blocker
        while(blocker <= m && B[blocker] < A[i] && (Xb - B[blocker] > Xa + A[i-1] || Xb + B[blocker] < Xa + A[i]))
            blocker++;

        if (blocker > 1 && blocker <= m && B[blocker] > A[i])
            blocker--;

        bool isBlocked = (blocker <= m && blocker >= 1) && (i > 1) && (B[blocker] <= A[i]) && (Xb - B[blocker] <= Xa + A[i-1]) && (Xb + B[blocker] >= Xa + A[i]);

        if (equalizer && B[blocker] == A[i])
            isBlocked = false;

        ///Chops
        while(firstChop > 1 && B[firstChop-1] >= A[i] && Xb - B[firstChop-1] <= Xa + A[i-1])
            firstChop--;
        while(firstChop <= m && B[firstChop] < A[i])
            firstChop++;

        if (!equalizer && firstChop <= m && B[firstChop] == A[i])
            firstChop++;

        while(lastChop < m && Xb - B[lastChop+1] >= Xa - A[i-1])
            lastChop++;

        int chops = (firstChop <= lastChop) ? (lastChop - firstChop + 1) : 0;

        if (firstNice <= lastNice)
            ans += (lastNice - firstNice + 1);
        if (isBlocked && chops > 0)
            ans++;
        if (chops > 0)
            ans += chops - 1;
    }

    return ans;
}

int main()
{
    int i,j;
    llong ans = 0;

    scanf("%d",&n);
    scanf("%d",&Xa);

    for (i=1;i<=n;i++)
    {
        scanf("%d",&A[i]);
        A[i] /= 2;
    }

    scanf("%d",&m);
    scanf("%d",&Xb);

    for (i=1;i<=m;i++)
    {
        scanf("%d",&B[i]);
        B[i] /= 2;
    }

    if (Xa == Xb) /// Corner case
    {
        set<int> all;
        for (i=1;i<=n;i++)
        {
            all.insert(A[i]);
        }
        for (i=1;i<=m;i++)
        {
            all.insert(B[i]);
        }
        printf("%d\n",all.size());
        return 0;
    }

    sort(A+1,A+1+n);
    sort(B+1,B+1+m);

    ans = n + m;
    ans += getAreas(true);
    invert();
    ans += getAreas(false);

    printf("%lld\n",ans);

    return 0;
}
