#include<iostream>
#include<unordered_map>
#include<algorithm>
#include<stdio.h>
#include<queue>
#include<set>
using namespace std;
int sq[2][50000];
struct point {
    int coord;
    int orient;
    int ind;
};
point segs[200000];
int len;
set <point> active[2];
set <point>::iterator sit;
unordered_map <int, vector <int> > px;
unordered_map <long long int, vector <int> > py;
unordered_map <long long int, bool> used;
unordered_map <int, vector <int> >::iterator mit;
bool operator< (point ex1, point ex2) {
    if (ex1.coord<ex2.coord) return true;
    if ((ex1.coord==ex2.coord)&&(ex1.orient<ex2.orient)) return true;
    return false;
}
const long long int maxy=1e9;
void add_edge (long long int x1, long long int y1, long long int x2) {
    py[x1*maxy+y1].push_back(x2);
    py[x2*maxy+y1].push_back(x1);
}
int main () {
    int n,center[2],i,j,ans=0,ind,sides[2];
    long long int vers=0,edges=0,comps=0;
    point curr;
    queue <pair <int, int> > bfs;
    pair <int, int> currv,nxtv;
    for (i=0; i<2; i++) {
        scanf("%d%d",&n,&center[i]);
        for (j=0; j<n; j++) {
            scanf("%d",&sq[i][j]);

            if (i==0) curr={center[i]-sq[i][j]/2,+1,j+1};
            else curr={center[i]-sq[i][j]/2,+1,-j-1};
            segs[len++]=curr;
            if (i==0) curr={center[i]+sq[i][j]/2,-1,j+1};
            else curr={center[i]+sq[i][j]/2,-1,-j-1};
            segs[len++]=curr;

            px[center[i]-sq[i][j]/2].push_back(-sq[i][j]/2); px[center[i]-sq[i][j]/2].push_back(sq[i][j]/2);
            px[center[i]+sq[i][j]/2].push_back(-sq[i][j]/2); px[center[i]+sq[i][j]/2].push_back(sq[i][j]/2);

            add_edge(center[i]-sq[i][j]/2,-sq[i][j]/2,center[i]+sq[i][j]/2);
            add_edge(center[i]-sq[i][j]/2,sq[i][j]/2,center[i]+sq[i][j]/2);
            edges+=2;
            }
        }

    sort(segs,segs+len);
    for (i=0; i<len; i++) {
        if (segs[i].ind>0) {
           ind=0;
           segs[i].ind--;
           }
        else {
            ind=1;
            segs[i].ind=-segs[i].ind-1;
            }
        if (segs[i].orient==1) {
           active[ind].insert(segs[i]);
           continue;
           }
        for (sit=active[ind^1].lower_bound({center[ind]-sq[ind][segs[i].ind]/2+1,-2,0}); sit!=active[ind^1].end(); sit++) {
            sides[ind]=sq[ind][segs[i].ind]/2; sides[ind^1]=sq[ind^1][sit->ind]/2;
            if (sides[ind]==sides[ind^1]) {
               add_edge(center[ind]-sides[ind],sides[ind],center[ind^1]-sides[ind^1]);
               add_edge(center[ind^1]-sides[ind^1],sides[ind^1],center[ind]+sides[ind]);
               add_edge(center[ind]+sides[ind],sides[ind],center[ind^1]+sides[ind^1]);
               edges+=2;
               }
            if ((sides[ind]==sides[ind^1])||(center[ind]+sides[ind]==center[ind^1]+sides[ind^1])) continue;
            //cout << i << " " << ind << " " << sides[ind]*2 << " " << sides[ind^1]*2 << endl ;
            if (sides[ind]>sides[ind^1]) {
               px[segs[i].coord].push_back(-sides[ind^1]); px[segs[i].coord].push_back(sides[ind^1]);
               add_edge(center[ind^1]-sides[ind^1],sides[ind^1],segs[i].coord);
               add_edge(segs[i].coord,sides[ind^1],center[ind^1]+sides[ind^1]);

               add_edge(center[ind^1]-sides[ind^1],-sides[ind^1],segs[i].coord);
               add_edge(segs[i].coord,-sides[ind^1],center[ind^1]+sides[ind^1]);
               }
            else {
                px[sit->coord].push_back(-sides[ind]); px[sit->coord].push_back(sides[ind]);
                add_edge(center[ind]-sides[ind],sides[ind],sit->coord);
                add_edge(sit->coord,sides[ind],center[ind]+sides[ind]);

                add_edge(center[ind]-sides[ind],-sides[ind],sit->coord);
                add_edge(sit->coord,-sides[ind],center[ind]+sides[ind]);
                }
            edges+=2;
            }
        active[ind].erase({center[ind]-sq[ind][segs[i].ind]/2,1,segs[i].ind});
        }

    for (mit=px.begin(); mit!=px.end(); mit++) {
        vers+=mit->second.size();
        edges+=mit->second.size()-1;
        /*cout << mit->second.size()-1 << "   ";
        for (i=0; i<mit->second.size(); i++) {
            cout << mit->first << " " << mit->second[i] << "  ";
            }
        cout << endl ;*/
        if (used.count(mit->first*maxy+mit->second[0])==1) continue;

        comps++;
        used[mit->first*maxy+mit->second[0]]=1;
        bfs.push({mit->first,mit->second[0]});
        //cout << mit->first << " ";
        for (;;) {
            if (bfs.empty()==1) break;
            currv=bfs.front(); //if (currv.first==11) cout << "a";
            for (i=0; i<px[currv.first].size(); i++) {
                nxtv.first=currv.first; nxtv.second=px[currv.first][i];
                if (used.count(nxtv.first*maxy+nxtv.second)==0) {
                   used[nxtv.first*maxy+nxtv.second]=1;
                   bfs.push(nxtv);
                   }
               }
            for (i=0; i<py[currv.first*maxy+currv.second].size(); i++) {
                nxtv.first=py[currv.first*maxy+currv.second][i]; nxtv.second=currv.second;
                if (used.count(nxtv.first*maxy+nxtv.second)==0) {
                   used[nxtv.first*maxy+nxtv.second]=1;
                   bfs.push(nxtv);
                   }
                }
            bfs.pop();
            }
        }

    //cout << vers << " " << edges << " " << comps ;
    cout << comps+edges-vers ;
    cout << endl ;
    return 0;
}
